# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/06_filt.ipynb.

# %% auto 0
__all__ = ['just', 'justabc', 'justnum', 'justpunc', 'droppunc', 'splitget', 'prepart', 'midpart', 'endpart', 'isdunder',
           'todunder']

# %% ../nbs/06_filt.ipynb 4
import string
from typing import Callable, Optional, TypeGuard
from .cons import NIL, SPACE, SUNDER

# %% ../nbs/06_filt.ipynb 5
def just(s: str, flag: Callable[[str], bool]) -> str:
    '''Filters a string for just the specified characters'''
    return ''.join(list(filter(flag, s)))

def justabc(s: str) -> str:
    '''Filters a string for just alpha values'''
    return just(s, str.isalpha)

def justnum(s: str) -> str:
    '''Filters a string for just numeric values'''
    return just(s, str.isnumeric)

def justpunc(s: str) -> str:
    '''Filters a string for just punctuation values'''
    return just(s, string.punctuation)
    
def droppunc(s: str) -> str:
    return s.translate(str.maketrans(NIL, NIL, string.punctuation))

def splitget(s: str, sep: str = SUNDER, idx: int = 0) -> str:
    parts = s.split(sep)
    return parts[idx]    

def prepart(s:str, sep: Optional[str] = SPACE) -> str:
    pre, *_ = s.partition(sep)
    return pre

def midpart(s:str, sep: Optional[str] = SPACE) -> str:
    _, mid, _ = s.partition(sep)
    return mid

def endpart(s:str, sep: Optional[str] = SPACE) -> str:
    *_, end = s.partition(sep)
    return end

# %% ../nbs/06_filt.ipynb 6
def isdunder(s: str) -> TypeGuard[str]:
    return isinstance(s, str) and s.startswith('__') and s.endswith('__') and len(s) > 4

def todunder(s: str) -> str:
    return f'__{s}__' if not isdunder(s) else s
