# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/01_pttn.ipynb.

# %% auto 0
__all__ = ['BASIC_WORDS_TO_SNAKE', 'WORDS_TO_SNAKE_WITH_UPPERCASE', 'CAMEL_TO_SNAKE', 'PASCAL_TO_SNAKE', 'SNAKE_PATTERNS']

# %% ../nbs/01_pttn.ipynb 4
import re

# %% ../nbs/01_pttn.ipynb 8
BASIC_WORDS_TO_SNAKE = re.compile(
    r'[A-Z]?[a-z]+'                     # A possible uppercase followed by lowercase letters
    r'|[A-Z]{2,}(?=[A-Z][a-z]|\d|\W|$)' # Two or more consecutive uppercase letters
    r'|\d+'                             # One or more digits
)

# %% ../nbs/01_pttn.ipynb 9
WORDS_TO_SNAKE_WITH_UPPERCASE = re.compile(
    r'[A-Z]?[a-z]+'                     # A possible uppercase followed by lowercase letters
    r'|[A-Z]{2,}(?=[A-Z][a-z]|\d|\W|$)' # Two or more consecutive uppercase letters
    r'|\d+'                             # One or more digits
    r'|[A-Z]{2,}'                       # Two or more consecutive uppercase letters
    r'|[A-Z]$'                          # Uppercase letter at end of string
)

# %% ../nbs/01_pttn.ipynb 13
CAMEL_TO_SNAKE = re.compile(
    r'(?<=[a-z0-9])[A-Z]'          # An uppercase letter after a lowercase letter / digit
    r'|(?<![A-Z_])[A-Z](?=[a-z])'  # An uppercase letter before a lowercase letter AND 
                                   # not after an uppercase letter or underscore
)

# %% ../nbs/01_pttn.ipynb 17
PASCAL_TO_SNAKE = re.compile(
    r'(?!^)(?<!_)[A-Z][a-z]+'     # An uppercase letter not at the start and not after an underscore, 
                                  # followed by one or more lowercase letters (captures beginning of PascalCase words)
    r'|(?<=[a-z0-9])[A-Z]'        # An uppercase letter after a lowercase letter or digit 
                                  # (captures transition in camelCase)
)

# %% ../nbs/01_pttn.ipynb 19
SNAKE_PATTERNS = (BASIC_WORDS_TO_SNAKE, WORDS_TO_SNAKE_WITH_UPPERCASE, CAMEL_TO_SNAKE, PASCAL_TO_SNAKE,)
