# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/04_sens.ipynb.

# %% auto 0
__all__ = ['sens']

# %% ../nbs/04_sens.ipynb 4
import re
from regsyn import globsyn

# %% ../nbs/04_sens.ipynb 5
@globsyn({'sens', 'sensify'})
def sens(s: str, icase: bool = True, ispace: bool = True, iunder: bool = True, **kwargs) -> str:
    '''Prepare a string by applying case and space insensitivity rules.
    
    Parameters
    ----------
    icase : bool, optional
        Whether to ignore case when matching, by default True.
    ispace : bool, optional
        Whether to ignore spaces when matching, by default True.
    iunder : bool, optional
        Whether to ignore underscores when matching, by default True.    
    '''
    if icase:
        s = s.lower()
    if ispace:
        s = re.sub(r'\s', '', s)
    if iunder:
        s = re.sub(r'_', '', s)        
    return s
