# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/03_snek.ipynb.

# %% auto 0
__all__ = ['snek', 'py_to_snake']

# %% ../nbs/03_snek.ipynb 4
import re
from regsyn import globsyn
from .cons import SUNDER
from .repl import joinall
from .pttn import WORDS_TO_SNAKE_WITH_UPPERCASE, SNAKE_PATTERNS

# %% ../nbs/03_snek.ipynb 5
@globsyn({'snake', 'to_snake', 'snakify', 'snakify'})
def snek(s: str) -> str:
    '''Convert a string to snake_case'''
    return joinall(s, WORDS_TO_SNAKE_WITH_UPPERCASE, SUNDER).lower()

    
def py_to_snake(s: str) -> str:    
    '''Convert a string to snake_case without using `re`'''
    _precap = [f'_{c.lower()}' if c.isupper() else c for c in s]
    return ''.join(_precap).lstrip(SUNDER)
